$Ansible.Failed = $false
$Ansible.Changed = $false
$packageProviderName = "{{ win_package_provider }}"
{% if win_proxy_url is defined %}
$proxy = '{{ win_proxy_url }}'
[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12
[system.net.webrequest]::defaultwebproxy = new-object system.net.webproxy($proxy)
[system.net.webrequest]::defaultwebproxy.BypassProxyOnLocal = $true
{% endif %}

Write-Output "Install $packageProviderName Package Provider (if not installed already)"

try {
    $availableProviders = Get-PackageProvider -ListAvailable | Where-Object { $_.Name -eq "$packageProviderName" }

    if (-not $availableProviders) {
        Write-Output "Installing $packageProviderName Package Provider"
        $result = Install-PackageProvider -Name "$packageProviderName" -Force -Confirm:$false

        if ($result -eq $null) {
            $Ansible.Failed = $true
            Write-Error "Failed to install $packageProviderName Package Provider"
        } else {
            $Ansible.Changed = $true
        }
    }

    if ($Ansible.Changed) {
        Write-Output "$packageProviderName Package Provider has been installed or updated."
    } elseif ($Ansible.Failed) {
        Write-Output "$packageProviderName Package Provider failed to install."
    }
    else {
        Write-Output "$packageProviderName Package Provider is installed, and the installation was not changed"
    }
}
catch {
    $Ansible.Failed = $true
    Write-Error "An error occurred: $_"
}
